org.thewonderlemming.c4plantuml.testbed.mojo.linting.rules.custom

## Class TestableAbstractCustomLintingRule

- java.lang.Object
- - org.thewonderlemming.c4plantuml.linter.rules.AbstractLintingRule
  - - org.thewonderlemming.c4plantuml.mojo.linting.rules.custom.AbstractCustomLintingRule
    - - org.thewonderlemming.c4plantuml.testbed.mojo.linting.rules.custom.TestableAbstractCustomLintingRule

-     public class TestableAbstractCustomLintingRule
      extends AbstractCustomLintingRule

  A non-abstract implementation of the `AbstractCustomLintingRule` for testing purposes.
  Author:
    thewonderlemming

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `TestableAbstractCustomLintingRule.TestableParseTreeListener` An implementation of the `C4BaseListener` for the sake of the test implemntation.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `THROW_ASSERT_ON_SYNTAX_ERROR_PARAMETER_NAME` The name of the parameter that enables the current rule to throw `AssertionError` on syntax erors.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `TestableAbstractCustomLintingRule(RuleParameters parameters)` Default constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Set<Class<? extends org.antlr.v4.runtime.Parser>>` | `acceptableParsersTypes()`
    `Optional<? extends org.antlr.v4.runtime.tree.ParseTreeListener>` | `createParseTreeListener(org.thewonderlemming.c4plantuml.commons.Reporter reporter, Class<? extends org.antlr.v4.runtime.Parser> parser)`
    `static File` | `getReportFile()` Returns the file that holds the reports made by the current rule.
    `Optional<org.antlr.v4.runtime.tree.ParseTree>` | `selectParseTree(org.antlr.v4.runtime.Parser parser)`
    `void` | `wrapUp()`

    - ### Methods inherited from class org.thewonderlemming.c4plantuml.linter.rules.AbstractLintingRule

      `clearSyntaxErrors, getLogger, getParameters, getSyntaxErrors, reportSyntaxError`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### THROW_ASSERT_ON_SYNTAX_ERROR_PARAMETER_NAME

          public static final String THROW_ASSERT_ON_SYNTAX_ERROR_PARAMETER_NAME

      The name of the parameter that enables the current rule to throw `AssertionError` on syntax erors.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### TestableAbstractCustomLintingRule

          protected TestableAbstractCustomLintingRule(RuleParameters parameters)

      Default constructor.
      Parameters:
        `parameters` - the `RuleParameters` POJO to configure the current rule.

  - ### Method Detail

    - #### getReportFile

          public static File getReportFile()

      Returns the file that holds the reports made by the current rule.
      Returns:
        the file holding the reports made by the current rule.

    - #### acceptableParsersTypes

          public Set<Class<? extends org.antlr.v4.runtime.Parser>> acceptableParsersTypes()

      Specified by:
        `acceptableParsersTypes` in class `AbstractLintingRule`

    - #### createParseTreeListener

          public Optional<? extends org.antlr.v4.runtime.tree.ParseTreeListener> createParseTreeListener(org.thewonderlemming.c4plantuml.commons.Reporter reporter,
                                                                                                         Class<? extends org.antlr.v4.runtime.Parser> parser)

      Specified by:
        `createParseTreeListener` in class `AbstractLintingRule`

    - #### selectParseTree

          public Optional<org.antlr.v4.runtime.tree.ParseTree> selectParseTree(org.antlr.v4.runtime.Parser parser)

      Specified by:
        `selectParseTree` in class `AbstractLintingRule`

    - #### wrapUp

          public void wrapUp()

      Specified by:
        `wrapUp` in class `AbstractLintingRule`

Copyright © 2020. All rights reserved.